/*
 * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
 * Copyright (C) 2008 Alp Toker <alp@atoker.com>
 * Copyright (C) 2008 Apple Inc.
 */
#ifndef __GdomHTMLSelectElement_H__
#define __GdomHTMLSelectElement_H__
#include <webkit/webkitdefines.h>
#include "gdom/GdomHTMLElement.h"
#include "gdom/GdomNode.h"
#include "glib-object.h"


G_BEGIN_DECLS

typedef struct _GdomHTMLSelectElement GdomHTMLSelectElement;
typedef struct _GdomHTMLSelectElementClass GdomHTMLSelectElementClass;


#define GDOM_TYPE_HTML_SELECT_ELEMENT            (gdom_html_select_element_get_type())
#define GDOM_HTML_SELECT_ELEMENT(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), GDOM_TYPE_HTML_SELECT_ELEMENT, GdomHTMLSelectElement))
#define GDOM_HTML_SELECT_ELEMENT_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  GDOM_TYPE_HTML_SELECT_ELEMENT, GdomHTMLSelectElement)Class)
#define GDOM_IS_HTML_SELECT_ELEMENT(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), GDOM_TYPE_HTML_SELECT_ELEMENT))
#define GDOM_IS_HTML_SELECT_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  GDOM_TYPE_HTML_SELECT_ELEMENT))
#define GDOM_HTML_SELECT_ELEMENT_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  GDOM_TYPE_HTML_SELECT_ELEMENT, GdomHTMLSelectElementClass))

typedef struct _GdomHTMLSelectElementPrivate GdomHTMLSelectElementPrivate;

struct _GdomHTMLSelectElement {
    GdomHTMLElement parent_instance;
    GdomHTMLSelectElementPrivate *priv;
};

struct _GdomHTMLSelectElementClass {
    GObjectClass parent_class;
};

WEBKIT_API GType
gdom_html_select_element_get_type (void);

WEBKIT_API void
gdom_html_select_element_add (GdomHTMLSelectElement *thiz, GdomHTMLElement * element, GdomHTMLElement * before);

WEBKIT_API void
gdom_html_select_element_remove (GdomHTMLSelectElement *thiz, glong index);

WEBKIT_API GdomNode *
gdom_html_select_element_item (GdomHTMLSelectElement *thiz, gulong index);

WEBKIT_API GdomNode *
gdom_html_select_element_named_item (GdomHTMLSelectElement *thiz, gchar * name);

G_END_DECLS

#endif /* __GdomHTMLSelectElement_H__ */
